/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of SMIME.xs. Do not edit this file, edit SMIME.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "SMIME.xs"
#include <string.h>
#include <stdlib.h>
#include <openssl/crypto.h>
#include <openssl/pem.h>
#include <openssl/err.h>
#include <openssl/pkcs12.h>
#include <openssl/x509.h>

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

struct crypt_smime {
    EVP_PKEY *priv_key;
    X509* priv_cert;

    const EVP_CIPHER* cipher;

    /* 暗号化, 添付用 */
    STACK_OF(X509)* pubkeys_stack;

    /* 検証用 */
    X509_STORE* pubkeys_store;
};
typedef struct crypt_smime * Crypt_SMIME;

#define OPENSSL_CROAK(description) 				\
    croak("%s: %s",						\
	  description,						\
	  ERR_error_string(ERR_get_error(), NULL))

/* B64_write_PKCS7 is copyed from openssl/crypto/pkcs7/pk7_mime.c */
static int B64_write_PKCS7(BIO *bio, PKCS7 *p7)
{
        BIO *b64;
        if(!(b64 = BIO_new(BIO_f_base64()))) {
                PKCS7err(PKCS7_F_B64_WRITE_PKCS7,ERR_R_MALLOC_FAILURE);
                return 0;
        }
        bio = BIO_push(b64, bio);
        i2d_PKCS7_bio(bio, p7);
        (void)BIO_flush(bio);
        bio = BIO_pop(bio);
        BIO_free(b64);
        return 1;
}


static EVP_PKEY* load_privkey(Crypt_SMIME this, char* pem, char* password) {
    BIO *buf;
    EVP_PKEY *key;

    buf = BIO_new_mem_buf(pem, -1);
    if (buf == NULL) {
        return NULL;
    }

    key = PEM_read_bio_PrivateKey(
	buf, NULL, (pem_password_cb*)NULL, password);
    BIO_free(buf);

    return key;
}

/* ----------------------------------------------------------------------------
 * X509* x509 = load_cert(crt);
 * extract X509 information from cert data.
 * not from file, from just data.
 * ------------------------------------------------------------------------- */
static X509* load_cert(char* crt) {
    BIO* buf;
    X509 *x;

    buf = BIO_new_mem_buf(crt, -1);
    if (buf == NULL) {
	return NULL;
    }

    x = PEM_read_bio_X509_AUX(buf, NULL, NULL, NULL);
    BIO_free(buf);

    return x;
}

static SV* sign(Crypt_SMIME this, char* raw) {
    BIO* inbuf;
    BIO* outbuf;
    PKCS7* pkcs7;
    int flags = PKCS7_DETACHED;
    BUF_MEM* bufmem;
    SV* result;
    int err;

    inbuf = BIO_new_mem_buf(raw, -1);
    if (inbuf == NULL) {
	return NULL;
    }

    /*クリア署名を作る */
    pkcs7 = PKCS7_sign(this->priv_cert, this->priv_key, NULL, inbuf, flags);
    
    if (pkcs7 == NULL) {
	return NULL;
    }

    outbuf = BIO_new(BIO_s_mem());
    if (outbuf == NULL) {
	PKCS7_free(pkcs7);
	return NULL;
    }

    (void)BIO_reset(inbuf);

    {
      int i;
      for( i=0; i< sk_X509_num(this->pubkeys_stack); ++i )
      {
        X509* x509 = sk_X509_value(this->pubkeys_stack,i);
        assert( x509!=NULL );
        PKCS7_add_certificate(pkcs7, x509);
      }
    }
    
    err = SMIME_write_PKCS7(outbuf, pkcs7, inbuf, flags);
    PKCS7_free(pkcs7);
    BIO_free(inbuf);

    if (err != 1) {
	return NULL;
    }

    BIO_get_mem_ptr(outbuf, &bufmem);
    result = newSVpv(bufmem->data, bufmem->length);
    BIO_free(outbuf);

    return result;
}

static SV* signonly(Crypt_SMIME this, char* raw) {
    BIO* inbuf;
    BIO* outbuf;
    PKCS7* pkcs7;
    int flags = PKCS7_DETACHED;
    BUF_MEM* bufmem;
    SV* result;
    int err;

    inbuf = BIO_new_mem_buf(raw, -1);
    if (inbuf == NULL) {
	return NULL;
    }

    /*クリア署名を作る */
    pkcs7 = PKCS7_sign(this->priv_cert, this->priv_key, NULL, inbuf, flags);
    
    BIO_free(inbuf);
    
    if (pkcs7 == NULL) {
	return NULL;
    }

    outbuf = BIO_new(BIO_s_mem());
    if (outbuf == NULL) {
	PKCS7_free(pkcs7);
	return NULL;
    }

    {
      int i;
      for( i=0; i< sk_X509_num(this->pubkeys_stack); ++i )
      {
        X509* x509 = sk_X509_value(this->pubkeys_stack,i);
        assert( x509!=NULL );
        PKCS7_add_certificate(pkcs7, x509);
      }
    }
    
    err = B64_write_PKCS7(outbuf, pkcs7);
    PKCS7_free(pkcs7);

    if (err != 1) {
	return NULL;
    }

    BIO_get_mem_ptr(outbuf, &bufmem);
    result = newSVpv(bufmem->data, bufmem->length);
    BIO_free(outbuf);

    return result;
}

static SV* check(Crypt_SMIME this, char* signed_mime) {
    BIO* inbuf;
    BIO* detached = NULL;
    BIO* outbuf;
    PKCS7* sign;
    int flags = 0;
    int err;
    BUF_MEM* bufmem;
    SV* result;

    inbuf = BIO_new_mem_buf(signed_mime, -1);
    if (inbuf == NULL) {
	return NULL;
    }

    sign = SMIME_read_PKCS7(inbuf, &detached);
    BIO_free(inbuf);
    
    if (sign == NULL) {
	return NULL;
    }

    outbuf = BIO_new(BIO_s_mem());
    if (outbuf == NULL) {
	PKCS7_free(sign);
	return NULL;
    }

    err = PKCS7_verify(sign, NULL, this->pubkeys_store, detached, outbuf, flags);
    PKCS7_free(sign);
    
    if (detached != NULL) {
	BIO_free(detached);
    }

    if (err <= 0) {
	BIO_free(outbuf);
	return NULL;
    }

    BIO_get_mem_ptr(outbuf, &bufmem);
    result = newSVpv(bufmem->data, bufmem->length);
    BIO_free(outbuf);

    return result;
}

static SV* _encrypt(Crypt_SMIME this, char* raw) {
    BIO* inbuf;
    BIO* outbuf;
    PKCS7* enc;
    int flags = 0;
    int err;
    BUF_MEM* bufmem;
    SV* result;

    inbuf = BIO_new_mem_buf(raw, -1);
    if (inbuf == NULL) {
	return NULL;
    }

    enc = PKCS7_encrypt(this->pubkeys_stack, inbuf, this->cipher, flags);
    BIO_free(inbuf);
    
    if (enc == NULL) {
	return NULL;
    }

    outbuf = BIO_new(BIO_s_mem());
    if (outbuf == NULL) {
	PKCS7_free(enc);
	return NULL;
    }

    err = SMIME_write_PKCS7(outbuf, enc, NULL, flags);
    PKCS7_free(enc);

    if (err != 1) {
	BIO_free(outbuf);
	return NULL;
    }

    BIO_get_mem_ptr(outbuf, &bufmem);
    result = newSVpv(bufmem->data, bufmem->length);
    BIO_free(outbuf);

    return result;
}

static SV* _decrypt(Crypt_SMIME this, char* encrypted_mime) {
    BIO* inbuf;
    BIO* outbuf;
    PKCS7* enc;
    int flags = 0;
    int err;
    BUF_MEM* bufmem;
    SV* result;

    inbuf = BIO_new_mem_buf(encrypted_mime, -1);
    if (inbuf == NULL) {
	return NULL;
    }

    enc = SMIME_read_PKCS7(inbuf, NULL);
    BIO_free(inbuf);

    if (enc == NULL) {
	return NULL;
    }

    outbuf = BIO_new(BIO_s_mem());
    if (outbuf == NULL) {
	PKCS7_free(enc);
	return NULL;
    }

    err = PKCS7_decrypt(enc, this->priv_key, this->priv_cert, outbuf, flags);
    PKCS7_free(enc);

    if (err != 1) {
	BIO_free(outbuf);
	return NULL;
    }

    BIO_get_mem_ptr(outbuf, &bufmem);
    result = newSVpv(bufmem->data, bufmem->length);
    BIO_free(outbuf);

    return result;
}

static void seed_rng() {
    RAND_poll();

    while (RAND_status() == 0) {
	long seed = random();
	RAND_seed(&seed, sizeof(long));
    }
}


#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 347 "SMIME.c"

XS(XS_Crypt__SMIME__init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__SMIME__init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::SMIME::_init", "char* /*CLASS*/");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 338 "SMIME.xs"
        /* libcryptoの初期化 */
        ERR_load_crypto_strings();
        SSLeay_add_all_algorithms();
        seed_rng();
#line 366 "SMIME.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__SMIME_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__SMIME_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::SMIME::new", "char* /*CLASS*/");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Crypt_SMIME	RETVAL;
#line 346 "SMIME.xs"
        RETVAL = safemalloc(sizeof(struct crypt_smime));
	if (RETVAL == NULL) {
	    croak("Crypt::SMIME#new: unable to allocate Crypt_SMIME");
	}

        memset(RETVAL, '\0', sizeof(struct crypt_smime));

#line 393 "SMIME.c"
	ST(0) = sv_newmortal();
    sv_setref_pv(
        ST(0),
        "Crypt::SMIME",
        (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__SMIME_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__SMIME_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::SMIME::DESTROY", "this");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Crypt_SMIME	this;

    /* タイプ名のアンダースコアを::に変えたパッケージ名にblessされているのでなければcroak  */
    if (sv_derived_from(ST(0), "Crypt::SMIME")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        this = (Crypt_SMIME) tmp;
    }
    else {
        croak("this is not of type Crypt::SMIME");
    };
#line 359 "SMIME.xs"
        if (this->priv_cert) {
            X509_free(this->priv_cert);
        }
	if (this->priv_key) {
            EVP_PKEY_free(this->priv_key);
        }
	if (this->pubkeys_stack) {
	    sk_X509_free(this->pubkeys_stack);
	}
        if (this->pubkeys_store) {
            X509_STORE_free(this->pubkeys_store);
        }
        safefree(this);
#line 440 "SMIME.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__SMIME_setPrivateKey); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__SMIME_setPrivateKey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::SMIME::setPrivateKey", "this, pem, crt, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 377 "SMIME.xs"
        char* password = "";
        STRLEN n_a;

#line 462 "SMIME.c"
	SV *	RETVAL;
	Crypt_SMIME	this;
	char*	pem = (char *)SvPV_nolen(ST(1));
	char*	crt = (char *)SvPV_nolen(ST(2));

    /* タイプ名のアンダースコアを::に変えたパッケージ名にblessされているのでなければcroak  */
    if (sv_derived_from(ST(0), "Crypt::SMIME")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        this = (Crypt_SMIME) tmp;
    }
    else {
        croak("this is not of type Crypt::SMIME");
    };
#line 381 "SMIME.xs"
        if (items > 3) {
            password = (char*)SvPV(ST(3), n_a);
        }

        /* 古い鍵があったら消す */
        if (this->priv_cert) {
            X509_free(this->priv_cert);
	    this->priv_cert = NULL;
        }
	if (this->priv_key) {
            EVP_PKEY_free(this->priv_key);
	    this->priv_key = NULL;
        }

	this->priv_key = load_privkey(this, pem, password);
 	if (this->priv_key == NULL) {
	    OPENSSL_CROAK("Crypt::SMIME#setPrivateKey: failed to load the private key");
        }

	this->priv_cert = load_cert(crt);
	if (this->priv_cert == NULL) {
	    OPENSSL_CROAK("Crypt::SMIME#setPrivateKey: failed to load the private cert");
	}

	SvREFCNT_inc(ST(0));
	RETVAL = ST(0);

#line 504 "SMIME.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__SMIME_setPublicKey); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__SMIME_setPublicKey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::SMIME::setPublicKey", "this, crt");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	Crypt_SMIME	this;
	SV*	crt = ST(1);

    /* タイプ名のアンダースコアを::に変えたパッケージ名にblessされているのでなければcroak  */
    if (sv_derived_from(ST(0), "Crypt::SMIME")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        this = (Crypt_SMIME) tmp;
    }
    else {
        croak("this is not of type Crypt::SMIME");
    };
#line 414 "SMIME.xs"
        /*
	    crt: ARRAY Refなら、その各要素が公開鍵
                 SCALARなら、それが公開鍵
        */

        /* 古い鍵があったら消す */
	if (this->pubkeys_stack) {
	    sk_X509_free(this->pubkeys_stack);
	    this->pubkeys_stack = NULL;
	}
	if (this->pubkeys_store) {
	    X509_STORE_free(this->pubkeys_store);
	    this->pubkeys_store = NULL;
	}

        this->pubkeys_store = X509_STORE_new();
	if (this->pubkeys_store == NULL) {
	    croak("Crypt::SMIME#new: failed to allocate X509_STORE");
	}

	/* 何故STACK_OF(X509)とX509_STOREの二つを使う必要があるのか。 */
	this->pubkeys_stack = sk_X509_new_null();
	if (this->pubkeys_stack == NULL) {
	    croak("Crypt::SMIME#setPublicKey: failed to allocate STACK_OF(X509)");
	}

	if (SvROK(crt) && SvTYPE(SvRV(crt)) == SVt_PVAV) {
	    AV* array = (AV*)SvRV(crt);
	    I32 i, len = av_len(array);

	    for (i = 0; i <= len; i++) {
	        SV** val = av_fetch(array, i, 1);
		if (val == NULL) {
		    continue; /* 多分起こらないが… */
                }

		if (SvPOK(*val)) {
		    SV* this_sv = ST(0);

		    dSP;
		    ENTER;

		    PUSHMARK(SP);
		    XPUSHs(this_sv);
		    XPUSHs(*val);
		    PUTBACK;

		    call_method("_addPublicKey", G_DISCARD);

		    LEAVE;
		}
		else {
		    croak("Crypt::SMIME#setPublicKey: ARG[1] is an array but it contains some non-string values");
		}
	    }
	}
	else if (SvPOK(crt)) {
	    SV* this_sv = ST(0);

	    dSP;
	    ENTER;

	    PUSHMARK(SP);
	    XPUSHs(this_sv);
	    XPUSHs(crt);
	    PUTBACK;

	    call_method("_addPublicKey", G_DISCARD);

	    LEAVE;
	}
	else {
	    croak("Crypt::SMIME#setPublicKey: ARG[1] is not a string nor an ARRAY Ref");
	}

	SvREFCNT_inc(ST(0));
	RETVAL = ST(0);

#line 615 "SMIME.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__SMIME__addPublicKey); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__SMIME__addPublicKey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::SMIME::_addPublicKey", "this, crt");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 498 "SMIME.xs"
        X509* pub_cert;

#line 638 "SMIME.c"
	Crypt_SMIME	this;
	char*	crt = (char *)SvPV_nolen(ST(1));

    /* タイプ名のアンダースコアを::に変えたパッケージ名にblessされているのでなければcroak  */
    if (sv_derived_from(ST(0), "Crypt::SMIME")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        this = (Crypt_SMIME) tmp;
    }
    else {
        croak("this is not of type Crypt::SMIME");
    };
#line 501 "SMIME.xs"
        pub_cert = load_cert(crt);
	if (pub_cert == NULL) {
	    OPENSSL_CROAK("Crypt::SMIME#setPublicKey: failed to load the public cert");
	}

	if (X509_STORE_add_cert(this->pubkeys_store, pub_cert) == 0) {
	    X509_free(pub_cert);
	    OPENSSL_CROAK("Crypt::SMIME#setPublicKey: failed to store the public cert");
        }

	pub_cert = X509_dup(pub_cert);
	if (pub_cert == NULL) {
	    OPENSSL_CROAK("Crypt::SMIME#setPublicKey: failed to duplicate the X509 structure");
	}

	if (sk_X509_push(this->pubkeys_stack, pub_cert) == 0) {
	    X509_free(pub_cert);
	    OPENSSL_CROAK("Crypt::SMIME#setPublicKey: failed to push the public cert onto the stack");
	}
#line 670 "SMIME.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__SMIME__sign); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__SMIME__sign)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::SMIME::_sign", "this, raw");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	Crypt_SMIME	this;
	char*	raw = (char *)SvPV_nolen(ST(1));

    /* タイプ名のアンダースコアを::に変えたパッケージ名にblessされているのでなければcroak  */
    if (sv_derived_from(ST(0), "Crypt::SMIME")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        this = (Crypt_SMIME) tmp;
    }
    else {
        croak("this is not of type Crypt::SMIME");
    };
#line 524 "SMIME.xs"
        /* 秘密鍵がまだセットされていなければエラー */
        if (this->priv_key == NULL) {
	    croak("Crypt::SMIME#sign: private key has not yet been set. Set one before signing");
        }
        if (this->priv_cert == NULL) {
	    croak("Crypt::SMIME#sign: private cert has not yet been set. Set one before signing");
        }

        RETVAL = sign(this, raw);
        if (RETVAL == NULL) {
	    OPENSSL_CROAK("Crypt::SMIME#sign: failed to sign the message");
        }

#line 714 "SMIME.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__SMIME__signonly); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__SMIME__signonly)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::SMIME::_signonly", "this, raw");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	Crypt_SMIME	this;
	char*	raw = (char *)SvPV_nolen(ST(1));

    /* タイプ名のアンダースコアを::に変えたパッケージ名にblessされているのでなければcroak  */
    if (sv_derived_from(ST(0), "Crypt::SMIME")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        this = (Crypt_SMIME) tmp;
    }
    else {
        croak("this is not of type Crypt::SMIME");
    };
#line 543 "SMIME.xs"
        /* 秘密鍵がまだセットされていなければエラー */
        if (this->priv_key == NULL) {
	    croak("Crypt::SMIME#signonly: private key has not yet been set. Set one before signing");
        }
        if (this->priv_cert == NULL) {
	    croak("Crypt::SMIME#signonly: private cert has not yet been set. Set one before signing");
        }

        RETVAL = signonly(this, raw);
        if (RETVAL == NULL) {
	    OPENSSL_CROAK("Crypt::SMIME#signonly: failed to sign the message");
        }

#line 760 "SMIME.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__SMIME__encrypt); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__SMIME__encrypt)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::SMIME::_encrypt", "this, raw");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	Crypt_SMIME	this;
	char*	raw = (char *)SvPV_nolen(ST(1));

    /* タイプ名のアンダースコアを::に変えたパッケージ名にblessされているのでなければcroak  */
    if (sv_derived_from(ST(0), "Crypt::SMIME")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        this = (Crypt_SMIME) tmp;
    }
    else {
        croak("this is not of type Crypt::SMIME");
    };
#line 562 "SMIME.xs"
        /* 公開鍵がまだセットされていなければエラー */
	if (this->pubkeys_stack == NULL) {
	    croak("Crypt::SMIME#encrypt: public cert has not yet been set. Set one before encrypting");
	}

	/* cipherがまだ無ければ設定 */
	if (this->cipher == NULL) {
	    this->cipher = EVP_des_ede3_cbc();
	}

	RETVAL = _encrypt(this, raw);
	if (RETVAL == NULL) {
	    OPENSSL_CROAK("Crypt::SMIME#encrypt: failed to encrypt the message");
	}

#line 808 "SMIME.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__SMIME_check); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__SMIME_check)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::SMIME::check", "this, signed_mime");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	Crypt_SMIME	this;
	char*	signed_mime = (char *)SvPV_nolen(ST(1));

    /* タイプ名のアンダースコアを::に変えたパッケージ名にblessされているのでなければcroak  */
    if (sv_derived_from(ST(0), "Crypt::SMIME")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        this = (Crypt_SMIME) tmp;
    }
    else {
        croak("this is not of type Crypt::SMIME");
    };
#line 583 "SMIME.xs"
        /* 公開鍵がまだセットされていなければエラー */
	if (this->pubkeys_store == NULL) {
	    croak("Crypt::SMIME#check: public cert has not yet been set. Set one before checking");
	}

	RETVAL = check(this, signed_mime);
	if (RETVAL == NULL) {
	    OPENSSL_CROAK("Crypt::SMIME#check: failed to check the signature");
	}

#line 851 "SMIME.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__SMIME_decrypt); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__SMIME_decrypt)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::SMIME::decrypt", "this, encrypted_mime");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	Crypt_SMIME	this;
	char*	encrypted_mime = (char *)SvPV_nolen(ST(1));

    /* タイプ名のアンダースコアを::に変えたパッケージ名にblessされているのでなければcroak  */
    if (sv_derived_from(ST(0), "Crypt::SMIME")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        this = (Crypt_SMIME) tmp;
    }
    else {
        croak("this is not of type Crypt::SMIME");
    };
#line 599 "SMIME.xs"
        /* 秘密鍵がまだセットされていなければエラー */
        if (this->priv_key == NULL) {
	    croak("Crypt::SMIME#decrypt: private key has not yet been set. Set one before decrypting");
        }
        if (this->priv_cert == NULL) {
	    croak("Crypt::SMIME#decrypt: private cert has not yet been set. Set one before decrypting");
        }

	RETVAL = _decrypt(this, encrypted_mime);
        if (RETVAL == NULL) {
	    OPENSSL_CROAK("Crypt::SMIME#decrypt: failed to decrypt the message");
        }

#line 897 "SMIME.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__SMIME_x509_subject_hash); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__SMIME_x509_subject_hash)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::SMIME::x509_subject_hash", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	char*	cert = (char *)SvPV_nolen(ST(0));
#line 618 "SMIME.xs"
    {
      X509* x509 = load_cert(cert);
      if( x509!=NULL )
      {
        RETVAL = newSVuv(X509_subject_name_hash(x509));
        X509_free(x509);
      }else
      {
        RETVAL = &PL_sv_undef;
      }
    }
#line 931 "SMIME.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__SMIME_x509_issuer_hash); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__SMIME_x509_issuer_hash)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::SMIME::x509_issuer_hash", "cert");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	char*	cert = (char *)SvPV_nolen(ST(0));
#line 635 "SMIME.xs"
    {
      X509* x509 = load_cert(cert);
      if( x509!=NULL )
      {
        RETVAL = newSVuv(X509_issuer_name_hash(x509));
        X509_free(x509);
      }else
      {
        RETVAL = &PL_sv_undef;
      }
    }
#line 965 "SMIME.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Crypt__SMIME); /* prototype to pass -Wmissing-prototypes */
XS(boot_Crypt__SMIME)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("Crypt::SMIME::_init", XS_Crypt__SMIME__init, file);
        newXS("Crypt::SMIME::new", XS_Crypt__SMIME_new, file);
        newXS("Crypt::SMIME::DESTROY", XS_Crypt__SMIME_DESTROY, file);
        newXSproto("Crypt::SMIME::setPrivateKey", XS_Crypt__SMIME_setPrivateKey, file, "$$$;$");
        newXS("Crypt::SMIME::setPublicKey", XS_Crypt__SMIME_setPublicKey, file);
        newXS("Crypt::SMIME::_addPublicKey", XS_Crypt__SMIME__addPublicKey, file);
        newXS("Crypt::SMIME::_sign", XS_Crypt__SMIME__sign, file);
        newXS("Crypt::SMIME::_signonly", XS_Crypt__SMIME__signonly, file);
        newXS("Crypt::SMIME::_encrypt", XS_Crypt__SMIME__encrypt, file);
        newXS("Crypt::SMIME::check", XS_Crypt__SMIME_check, file);
        newXS("Crypt::SMIME::decrypt", XS_Crypt__SMIME_decrypt, file);
        newXS("Crypt::SMIME::x509_subject_hash", XS_Crypt__SMIME_x509_subject_hash, file);
        newXS("Crypt::SMIME::x509_issuer_hash", XS_Crypt__SMIME_x509_issuer_hash, file);
    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

